package com.menagerie.ophelia.database

import androidx.room.Dao
import androidx.room.Insert
import androidx.room.OnConflictStrategy
import androidx.room.Query
import kotlinx.coroutines.flow.Flow

@Dao
interface CandidateDao {

    @Query("SELECT * FROM candidate_table ORDER BY name ASC")
    fun getAlphabetisedList(): Flow<List<Candidate>>

    @Insert(onConflict = OnConflictStrategy.IGNORE)
    suspend fun insert(candidate: Candidate)

    @Query("DELETE FROM candidate_table")
    suspend fun deleteAll()
}